function Rext = comp_Rext_causal(Phi_m, G_lm, G_lm_t, p, r, causal_latent)


if causal_latent,
    %Compute Phi_lm
    Phi_lm = mult(G_lm,Phi_m);
    %Compute Phi_ml - this can be done without mult-function
    Phi_ml = mult(Phi_m,G_lm_t);
    %Compute Phi_ll
    Phi_ll = mult( Phi_lm, G_lm_t );
    Phi_ll{p+1} = Phi_ll{p+1} + eye(r,r);
else
    %Compute Phi_lm
    Phi_lm_temp = mult(G_lm,Phi_m);
    Phi_lm = trunc(Phi_lm_temp,p);
    %Compute Phi_ml - this can be done without mult-function
    Phi_ml = trunc( mult(Phi_m,G_lm_t), p);
    %Compute Phi_ll
    Phi_ll = trunc( mult( Phi_lm_temp, G_lm_t ), p );
    Phi_ll{p+1} = Phi_ll{p+1} + eye(r,r);
end
    
for kk=1:p+1,
    Rext{kk} = [
        Phi_m{p+kk}           Phi_ml{p+kk}
        Phi_lm{p+kk}          Phi_ll{p+kk}
    ];
end

end %function

