
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Phi_m(omega)                                                    = Phi_m
% -gamma_{lm}(omega)                                              = G_lm
% -gamma_{lm}(-omega)^\top                                        = G_lm_t
% -gamma_{lm}(omega)Phi_m(omega)                                  = Phi_lm
% -Phi_m(omega)gamma_{lm}(-omega)^\top                            = Phi_ml
% I+gamma_{lm}(omega)Phi_m(omega)gamma_{lm}(-omega)^\top          = Phi_ll
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
causal_latent = 0;                      %this value is recommended
adaptive = 1;                           %choose 0 for non-adaptive
K = 15;                                 %no. of manifest variables
r = 1;                                  %no. of latent variables
p = 1;                                  %VAR order
%Total no. of variables
n = K+r;
vec_N = [500 50000];                    %vector sample sizes                            
No_it = 2;                              %no. of iterations main loop                                 
%Parameters for get_mask
Ngrid = 1024;                           %no. points grid partial coherence 
flag_max = 1;                           %use max (not norm-2)
Th = 10^(-3);
%Parameter for true mask
vec_KS = [2 3 K];

No_tr = 1;                               %no. of trials
%Criteria
criteria = {'SBC', 'FPE', 'RNML', 'AICC', 'EBIC', 'EBICFD', 'RNMLFD'};
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ind_KS = 1:1,
    KS = vec_KS(ind_KS);
    for tr=1:No_tr,
        %Load data
        fdata = strcat('Data_KS', num2str(KS), '_tr', num2str(tr));
        load(fdata);
        all_data = data;
        for ind_N=2:2;
            N = vec_N(ind_N);
            fprintf('KS=%i tr=%i N=%i \n', KS, tr, N);
            %File results
            if causal_latent == 1,
                fres = strcat('Res_', num2str(KS), '_tr', num2str(tr), '_N', num2str(N), '_causal');
            else
                fres = strcat('Res_', num2str(KS), '_tr', num2str(tr), '_N', num2str(N));
            end
            %Data
            data = all_data(1:N,:); 
            %Values lambda
            vec_lam = 0.001:0.001:0.005; 
            % vec_lam = (10^(-3):10^(-3):10^(-1));
            %Estimate covariances
            Rest = comp_R(data, p);
            %Init
            [Phi_m, G_lm0, G_lm_t0] = init_algo(K, p, r, Rest);

            vec_crit = zeros(7,length(vec_lam));
            mask_old = Inf*ones(n,n);
            
            %Loop for lambda
            for ind_lam = 1:length(vec_lam),
                lam = vec_lam(ind_lam);
                %Main iterations
                [ISDM, G_lm, G_lm_t] = main_loop_causal(K, r, p, Phi_m, G_lm0, G_lm_t0, lam, No_it, causal_latent);
                fprintf('1');
                %Get mask
                mask = get_mask(n, ISDM, Ngrid, flag_max, Th);
                mask(:,K+1:K+r) = 1;
                mask(K+1:K+r,:) = 1;
                mask_estim = xor(mask, ones(n,n));
                if adaptive,
                    G_lm0 = G_lm;
                    G_lm_t0 = G_lm_t;
                end
                %Evaluate criteria
                if ( sum(sum(mask-mask_old)) ~=0 ),
                    vec_mask{ind_lam} = mask;
                    mask_old = mask;
                    ISDM = second_loop_causal(K, r, p, Phi_m, G_lm, G_lm_t, mask_estim, No_it, causal_latent);         
                    fprintf('2');
                    noz = sum(sum(mask_estim))/2;
                    %crit  = (1) SBC; (2) FPE; (3) RNML; (4) AICC; (5) EBIC; (6) EBICFD; (7) RNMLFD
                    for ind_crit=1:7,
                        vec_crit(ind_crit,ind_lam) = eval_crit(ind_crit, data, n, p, ISDM, noz);
                    end
                else
                    for ind_crit=1:7,
                        vec_crit(ind_crit,ind_lam) = vec_crit(ind_crit,ind_lam-1);
                    end
                    vec_mask{ind_lam} = vec_mask{ind_lam-1};
                end %if
                if mask(1:K,1:K)==eye(K,K),
                    for ii=ind_lam+1:length(vec_lam),
                        for ind_crit=1:7,
                            vec_crit(ind_crit,ii) = vec_crit(ind_crit,ind_lam);
                        end
                        vec_mask{ii} = mask;    
                    end
                    break;
                end %mask 
                save(fres, 'criteria', 'mask_true', 'vec_crit', 'vec_mask', 'vec_lam');
            end %ind_lam
            fprintf('\n');
            save(fres, 'criteria', 'mask_true', 'vec_crit', 'vec_mask', 'vec_lam');
        end %ind_N
    end %tr
end %KS 



