function Phi_tr = trunc(Phi, p)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%input:
% Phi       = polynomial with degree larger than p
% p         = degree for truncation
%output:
% Phi_tr    = truncated polynomial
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

gg = size(Phi,2);
cen = (gg+1)/2;
Phi_tr{p+1} = Phi{cen};
for kk=1:p,
    Phi_tr{p+1-kk} = Phi{cen-kk};
    Phi_tr{p+1+kk} = Phi{cen+kk};
end

end %function

